package reichert._02_bildbearbeitung;

import processing.core.PApplet;
import processing.core.PImage;

/**
 * Dieses Programm zeigt, wie ein Bild Pixel fr Pixel bearbeitet werden kann.
 * In dieser Variante werden doppelt geschachtelte Schleifen verwendet, um zu
 * zeigen, wie aus (x,y)-Koordinaten der Pixel-Array-Index berechnet wird.
 */
public class BildbearbeitungRotEntfernenMitDoppeltVerschachtelterSchleife extends PApplet {

	private static final long serialVersionUID = 1L;

	PImage original;
	PImage bearbeitet;

	public void setup() {
		original = loadImage("goldengate.jpg");
		original.loadPixels(); // initialisiere original.pixels
		// original.pixels enthlt jetzt alle Bildpunkte des in
		// der Variable original gespeicherten Bildes

		// erstelle neues, leeres Bild
		bearbeitet = new PImage(original.width, original.height);
		bearbeitet.loadPixels(); // initialisiere bearbeitet.pixels
		// bearbeitet.pixels enthlt original.width * original.height
		// Anzahl schwarzer Pixel

		for (int y = 0; y < original.height; y++) {
			for (int x = 0; x < original.width; x++) {
				int index = y * original.width + x;

				float gruen = green(original.pixels[index]);
				float blau = blue(original.pixels[index]);

				bearbeitet.pixels[index] = color(0, gruen, blau);
			}
		}
		bearbeitet.updatePixels(); // aktualisiere bearbeitet.pixels

		size(original.width * 2, original.height);
	}

	public void draw() {
		image(original, 0, 0, original.width, original.height);
		image(bearbeitet, original.width, 0, bearbeitet.width, bearbeitet.height);

	}

}
